"normalize.AffyBatch.vsn.val" <-
function(abatch, subsample=20000, ...){
###########################

    args = list(...)
    if("strata" %in% names(args)) stop("\n sorry, cant handle strata yet...\n")
    ind = unlist(indexProbes(abatch, "pm"))
    if (!is.na(subsample)) {
        if (!is.numeric(subsample))
            stop("'subsample' must be numeric.")
        if (length(ind) > subsample)
            ind = sample(ind, subsample)
    }
#    if (missing(strata))
#        strind <- rep(as.integer(1), length(ind))
#    else strind <- strata[ind]
    vsnres = vsn(intensity(abatch)[ind, ], ...)
    pars = preproc(description(vsnres))$vsnParams
    parsIter = preproc(description(vsnres))$vsnParamsIter
  
    ##=== calculate add-on parameters
    firstfac      = pars[1,1,2]
    TrimSelection = preproc(description(vsnres))$vsnTrimSelection
    mu        = apply(exprs(vsnres)[TrimSelection,]+log(2*firstfac),1,mean)
    c         = mean(( as.vector(exprs(vsnres)[TrimSelection,]+log(2*firstfac)) - mu )^2)
    if(!is.na(subsample)) TrimSelection=ind[TrimSelection]
    meanpars  = colMeans(preproc(description(vsnres))$vsnParams[1,,]) ##=== only ONE stratum 
    vsn.scale = list( 	TrimSelection = TrimSelection,
			mu            = mu,
			c             = c ,
			meanpars      = meanpars,
			firstfac      = firstfac)
    description(abatch)@preprocessing = c(description(abatch)@preprocessing,
       # list(val.method="vsn", vsnParams = pars, vsnParamsIter = parsIter, vsn.scale = vsn.scale))
        list( vsnParams = pars, vsnParamsIter = parsIter, 
              val=list(method="vsn",vsn.scale = vsn.scale)))
    intensity(abatch)  = exp(vsnh(intensity(abatch), pars ))
    return(abatch)
}

